<?php
namespace Folha\Entities;

use HCM\Util\DateUtil;
use Importacao\Logic\Integracao\ProjetoImportacao;

class MigVinculoh extends Base\MigVinculoh
{

    const DEFAULT_CONT_SIND = 'SEMPRE';
    const DEFAULT_TP_MOD_SAL = '1';
    const DEFAULT_IDMULTI_VINC = 'UNICO';
    const DEFAULT_IDTP_PAGAMENTO = 'MENSAL';
    const DEFAULT_IDREMUNERACAO = 'SAL1';
    const DEFAULT_NRTPMOVTRANSF = '2';
    const EXPRESSAO_NUMEROS = '/[^0-9]/';

    protected $dtultatu;
    protected $dtinclusao;
    protected $dtfimcontrdetermin;
    protected $dtmescompetenc;
    protected $dtbaseferias;

    /**
     * @param $nrvinculoh
     * @return \Folha\Entities\MigVinculoh
     */
    public function setNrvinculoh ($nrvinculoh) {
        $nrvinculoh = \Importacao\Logic\Validacoes::verificaChaveDuplicada('GPE_VINCULOH', 'NRVINCULOH', ProjetoImportacao::getNrorg(), $nrvinculoh);
        $this->nrvinculoh = $nrvinculoh;
    }

    /**
     * @param $nrvinculom
     * @return \Folha\Entities\MigVinculoh
     */
    public function setNrvinculom ($nrvinculom) {
        $nrvinculom = \Importacao\Logic\Validacoes::verificaChaveMae('GPE_VINCULOM', 'NRVINCULOM', ProjetoImportacao::getNrorg(), $nrvinculom);
        $this->nrvinculom = $nrvinculom;
    }

    /**
     * @param $idcontribuisind
     * @return \Folha\Entities\MigVinculoh
     */
    public function setIdcontribuisind ($idcontribuisind) {
        if (empty($idcontribuisind)) {
            $idcontribuisind = self::DEFAULT_CONT_SIND;
        }

        $this->idcontribuisind = $idcontribuisind;
    }

    /**
     * @param $nrtpmodalidsal
     * @return \Folha\Entities\MigVinculoh
     */
    public function setNrtpmodalidsal ($nrtpmodalidsal) {
        if (!empty($nrtpmodalidsal)) {
            $nrorg = ProjetoImportacao::getNrorgPadrao();
            $tipomodalidade = \Folha\Entities\FpaTpmodalidsal::getEntityByWhere('NRTPMODALIDSAL = ? AND NRORG = ?', array($nrtpmodalidsal, $nrorg));

            if (is_object($tipomodalidade)) {
                $this->nrtpmodalidsal = $nrtpmodalidsal;
            } else {
                $this->nrtpmodalidsal = self::DEFAULT_TP_MOD_SAL;
    //            throw new \Exception("O código de Tipo de Modalidade Salário '$nrtpmodalidsal' não foi encontrado.");
            }
        } else {
            $this->nrtpmodalidsal = self::DEFAULT_TP_MOD_SAL;
        }
    }

    /**
     * @param $nrsitufuncm
     * @throws \Exception
     * @return \Folha\Entities\MigVinculoh
     */
    public function setNrsitufuncm ($nrsitufuncm) {
        if (!empty($nrsitufuncm)) {
            $nrorg = ProjetoImportacao::getNrorgPadrao();            
            $situfunc = \Folha\Entities\GpeSitufuncm::findOneByNrsitufuncmAndNrorg($nrsitufuncm, $nrorg);

            if (is_object($situfunc)) {
                $this->nrsitufuncm = $nrsitufuncm;
            } else {
                \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, "O código da Situação Funcional '$nrsitufuncm' não foi encontrado.", null, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
        //            throw new \Exception("O código da Situação Funcional '$nrsitufuncm' não foi encontrado.");
            }
        } else {
            \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, "O código da Situação Funcional '$nrsitufuncm' não foi encontrado.", null, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
        }
    }

    /**
     * @param $nrescalatrabm
     * @throws \Exception
     * @return \Folha\Entities\MigVinculoh
     */
    public function setNrescalatrabm ($nrescalatrabm) {
        if ($nrescalatrabm != '') {
            $nrorg = ProjetoImportacao::getNrorg();
            $escalatrab = \Folha\Entities\MigEscalatrabm::getObjectByWhere('NRESCALATRABM = ? AND NRORG = ?', array($nrescalatrabm, $nrorg));

            if (is_object($escalatrab)) {
                $this->nrescalatrabm = $nrescalatrabm;
            } else {
                $this->nrescalatrabm = null;
                \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, "O código da Escala de Trabalho '$nrescalatrabm' não foi encontrado.", null, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
    //            throw new \Exception("O código da Escala de Trabalho '$nrescalatrabm' não foi encontrado.");
            }
        } else {
            $this->nrescalatrabm = null;
            \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, "O código da Escala de Trabalho '$nrescalatrabm' não foi encontrado.", null, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
        }
    }

// @TODO VALIDACOES DE ESTRUTRAS JÁ FORAM FEITAS NA ESTRUTURA.JSON
//    /**
//     * @param $nrestrutgeren
//     * @return \Folha\Entities\MigVinculoh
//     */
//    public function setNrestrutgeren ($nrestrutgeren) {
//        $nrestrutgeren = \Importacao\Logic\Validacoes::verificaChaveMae('ESTRUTURAM', 'NRESTRUTURAM', ProjetoImportacao::getNrorg(), $nrestrutgeren);
//        $this->nrestrutgeren = $nrestrutgeren;
//    }
//
//    /**
//     * @param $nrestrutlegal
//     * @return \Folha\Entities\MigVinculoh
//     */
//    public function setNrestrutlegal ($nrestrutlegal) {
//        $nrestrutlegal = \Importacao\Logic\Validacoes::verificaChaveMae('ESTRUTURAM', 'NRESTRUTURAM', ProjetoImportacao::getNrorg(), $nrestrutlegal);
//        $this->nrestrutlegal = $nrestrutlegal;
//    }
//
//    /**
//     * @param $nrestrutsind
//     * @return \Folha\Entities\MigVinculoh
//     */
//    public function setNrestrutsind ($nrestrutsind) {
//        $nrestrutsind = \Importacao\Logic\Validacoes::verificaChaveMae('ESTRUTURAM', 'NRESTRUTURAM', ProjetoImportacao::getNrorg(), $nrestrutsind);
//        $this->nrestrutsind = $nrestrutsind;
//    }

    /**
     * @param $nrcargo
     * @return \Folha\Entities\MigVinculoh
     */
    public function setNrcargo ($nrcargo) {
        if (!empty($nrcargo)) {
            $nrcargo = preg_replace(self::EXPRESSAO_NUMEROS, "", $nrcargo);

            $nrorg = ProjetoImportacao::getNrorg();
            $cargo = \Folha\Entities\MigOcupacaom::getObjectByWhere('NROCUPACAOM = ? AND NRORG = ?', array($nrcargo, $nrorg));

            if (is_object(($cargo))) {
                $this->nrcargo = $nrcargo;
                $this->nrfuncao = $nrcargo;
            } else {
                $this->nrcargo = null;
                $this->nrfuncao = null;
                \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, "O código da Ocupacao '$nrcargo' não foi encontrado.", null, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
            }
        } else {
            $this->nrcargo = null;
            $this->nrfuncao = null;
            \Importacao\Logic\Integracao\ProjetoImportacao::getInstancia()->criaLogDeItemProjeto(null, "O código da Ocupacao '$nrcargo' não foi encontrado.", null, null, \Geral\Entities\Logprojimport::VALIDACAO_INTEGRIDADE);
        }
    }

    /**
     * @param $idmultvinc
     * @return \Folha\Entities\MigVinculoh
     */
    public function setIdmultvinc ($idmultvinc) {
        if (empty($idmultvinc)) {
            $idmultvinc = self::DEFAULT_IDMULTI_VINC;
        }
        $this->idmultvinc = $idmultvinc;
    }

    /**
     * @param $idtppagamento
     * @return \Folha\Entities\MigVinculoh
     */
    public function setIdtppagamento ($idtppagamento) {
        if (empty($idtppagamento)) {
            $idtppagamento = self::DEFAULT_IDTP_PAGAMENTO;
        }
        $this->idtppagamento = $idtppagamento;
    }

    /**
     * @param $idremuneracao
     * @return \Folha\Entities\MigVinculoh
     */
    public function setIdremuneracao ($idremuneracao) {
        if (empty($idremuneracao)) {
            $idremuneracao = self::DEFAULT_IDREMUNERACAO;
        }
        $this->idremuneracao = $idremuneracao;
    }

    /**
     * @param mixed $dtbaseferias
     * @return \Folha\Entities\MigVinculoh|void
     */
    public function setDtbaseferias($dtbaseferias)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtbaseferias)) {
            if (!empty($dtbaseferias)) {
                throw new \Exception("Dt. Base Férias: Data '$dtbaseferias' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtbaseferias instanceof \DateTime)) {
            $dtbaseferias = DateUtil::getDataDeString($dtbaseferias);
        }

        $this->dtbaseferias = $dtbaseferias;
    }

    /**
     * @param mixed $dtfimcontrdetermin
     * @return \Folha\Entities\MigVinculoh|void
     */
    public function setDtfimcontrdetermin($dtfimcontrdetermin)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtfimcontrdetermin)) {
            if (!empty($dtfimcontrdetermin)) {
                throw new \Exception("Dt. Fim Contrato: Data '$dtfimcontrdetermin' com formato inválido ou em branco.");
            } else {
                throw new \Exception(null);
            }
        }

        if (!($dtfimcontrdetermin instanceof \DateTime)) {
            $dtfimcontrdetermin = DateUtil::getDataDeString($dtfimcontrdetermin);
        }

        $this->dtfimcontrdetermin = $dtfimcontrdetermin;
    }

    /**
     * @param mixed $dtinclusao
     * @return \Folha\Entities\MigVinculoh|void
     */
    public function setDtinclusao($dtinclusao)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtinclusao)) {
            throw new \Exception("Data '$dtinclusao' com formato inválido ou em branco.");
        }

        if (!($dtinclusao instanceof \DateTime)) {
            $dtinclusao = DateUtil::getDataDeString($dtinclusao);
        }

        $this->dtinclusao = $dtinclusao;
    }

    /**
     * @param mixed $dtmescompetenc
     * @return \Folha\Entities\MigVinculoh|void
     */
    public function setDtmescompetenc($dtmescompetenc)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtmescompetenc)) {
            throw new \Exception("Campo Obrigatório: Data '$dtmescompetenc' com formato inválido ou em branco.");
        }

        if (!($dtmescompetenc instanceof \DateTime)) {
            $dtmescompetenc = DateUtil::getDataDeString($dtmescompetenc);
        }

        $this->dtmescompetenc = $dtmescompetenc;
    }

    /**
     * @param mixed $dtultatu
     * @return \Folha\Entities\MigVinculoh|void
     */
    public function setDtultatu($dtultatu)
    {
        if (!preg_match("/\d{2}\/\d{2}\/\d{4}/", $dtultatu)) {
            throw new \Exception("Data '$dtultatu' com formato inválido ou em branco.");
        }

        if (!($dtultatu instanceof \DateTime)) {
            $dtultatu = DateUtil::getDataDeString($dtultatu);
        }

        $this->dtultatu = $dtultatu;
    }

    /**
     * @param $nrtpmovtransfm
     * @return \Folha\Entities\MigVinculoh
     */
    public function setNrtpmovtransfm ($nrtpmovtransfm) {
        if (empty($nrtpmovtransfm)) {
            $nrtpmovtransfm = self::DEFAULT_NRTPMOVTRANSF;
        }
        $this->nrtpmovtransfm = $nrtpmovtransfm;
    }
}