package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.WebElement;

public class LancamentoSolicitacaoComprasPage extends PageBase {
    //mapeando
    By UnidadeSolicitante = By.xpath("//div[@id='NMFILIAL']");
    //sub-filtro da unidade solicitante
    By UnidadeSolicitanteAux = By.xpath("//span[text() = 'DEPOSITO BC 129']");
    By UnidadeSolicitanteOK = By.xpath("//span[text() = 'Ok']");



    By TipoDeCustoField = By.xpath("//*[@id='NMTIPOCUSTO']/input");
    By TipoDeCustoAux = By.id("NMTIPOCUSTO");

    //loading filtro
    By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");
    By LinhaSelecionada = By.xpath("//span[text() = '1 linha selecionada']");

    By filtroAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro'][1]");
    By filtroFecharFiltro = By.xpath("//span[text() = 'Fechar'][1]");
    By filtroLimparFiltro = By.xpath("//a[@data-zh-title-tooltip = 'Clear Filter (Ctrl+Backspace)']");

    By adicionarLancamento = By.xpath("//a[@data-zh-title-tooltip = 'Adicionar (F2)']");

    //Filtro após clicar no icone de adicionar
    By UnidadeSolicitanteFiltro = By.xpath("//*[@id='NMFILIAL']/input");
    By Comprador = By.xpath("//*[@id='NMOPERADOR']/input");

    By Prosseguir = By.xpath("//span[text() = 'Prosseguir']");
    By Cancelar = By.xpath("//span[text() = 'Cancelar']");

    By AdicionarData = By.xpath("//*[@id='DTPROGENTR']");
    By IconeAdicionarData = By.xpath("//*[@id='ADD_DATA']");

    By Salvar = By.xpath("//span[text() = 'Salvar']");
    //Cancelar continua o mesmo

    //sub aba produtos - Grid com checkbox
    By Quantidade = By.xpath ("//*[@class='editable-content']");
    By QuantidadeAux = By.xpath("//*[@style='text-align: right; display: block;'] ");
    By QuantidadeAux2 = By.xpath ("//*[@class='inline-edit mousetrap ng-valid ng-valid-maxlength ng-touched ng-dirty ng-valid-parse']");
    By tela = By.xpath ("//*[@id='grid-1862797222207499468612']/div[@class='body']");
    By SalvarAlteracoes = By.xpath("//span[text() = 'Salvar alterações']");//span[text() = 'Salvar alterações']
    By Concluir = By.xpath("//span[text() = 'Concluir']");
    By clearFilter = By.xpath("//*[@data-zh-title-tooltip='Clear Filter (Ctrl+Backspace)']");

    //Aplicando parametros nos filtros
    public void preencherFiltroUnidadeSolicitante(String unidade){ //Base - preencherOperacao

        click(clearFilter);//clean filter

        click(UnidadeSolicitante);
        waitForInvisibilityOfElementLocated(loadingWait);
        //SendKeysJavaScript(UnidadeSolicitanteAux,unidade);
        //sendKeys(UnidadeSolicitanteAux,unidade);
        click(UnidadeSolicitanteAux);
        //waitForInvisibilityOfElementLocated(LinhaSelecionada);
        click(UnidadeSolicitanteOK);
    }
    public void preencherTipoCusto(String custo){ //Base - preencherUnidade
        click(TipoDeCustoAux);
        sendKeys(TipoDeCustoField,custo);
    }

    //Aplicando filtro
    public void clicarAplicarFiltro(){
        click(filtroAplicarFiltro);
    }

    //clicando em adicionar
    public void clicarAdicionar(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(adicionarLancamento);
    };

    //Aplicando parametros no filtro 2

    public void preencherFiltroInclusaoDeSolicitacao(String unidadeSolicitante, String adicionarData){
        click(UnidadeSolicitanteFiltro);
        sendKeys(UnidadeSolicitanteFiltro,unidadeSolicitante);
        click(Prosseguir);
        click(AdicionarData);
        sendKeys(AdicionarData,adicionarData);
        click(IconeAdicionarData);
        click(Salvar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

    public void PreencherQuantidade(String quantidadeProd){
        //waitForInvisibilityOfElementLocated(loadingWait);
        click(Quantidade);
        waitForVisibilityOfElementLocated(QuantidadeAux);
        sendKeys(QuantidadeAux,quantidadeProd);
        //sendKeys(QuantidadeAux2,quantidadeProd);
        click(tela);
        click(SalvarAlteracoes);
        waitForVisibilityOfElementLocated(Concluir);
        click(Concluir);
    }

}
